/* Backup Widget Contorller */
angular.module('backupCopyTargetModule',['dynamicdashboardapp','ui.dashboard'])
.controller('backupCopyTargetWidgetContorller', function ($scope,$rootScope, $http){
    $scope.widgetName="Backup Copy Target";
    $scope.modalShown=false;
    $scope.refreshKey="dash_replication_refresh";
    $scope.daysArray=["7/30","7/31","8/1","8/2","8/3","8/4","8/5"];
    $scope.maxValueArray=[];
    $scope.maxvalue=6;
    $scope.maxValuewithUnits="6 GB/s";
    $scope.dataValues=[[1,1,2,3,4,5,6]];
    $scope.units="GB";
    $scope.colorArray =["rgb(40,155,212)"];
    $scope.legends=["Data Transferred"];
    $scope.reSizeGraph=true;
    $scope.backupCopyTargetTableArray = [];
    $scope.viewLabel = "Table view";
    $scope.averageReplicatingSpeed = 0;
    $scope.toggleModal=function(){
	   $scope.modalShown=!$scope.modalShown;
    };
    $scope.graphShow=true;
    $scope.runReport = function(reportID, days, sid) {
        days = days || 0;
        sid = sid || 0;
        location.href = "#/reports/" + reportID + '/' + days + '/' + sid;
    };
    $rootScope.targetOptions=[
        { id : 0,  name: "All Targets" }
    ]
    $rootScope.target = {
      id: 0
    };
    
    $('.toggle-table').hide();
    $scope.toggleView = function() {
        //$(".toggle-graph-table").toggle();
         $('.toggle-table, .toggle-graph').toggle();
        $scope.graphShow = !$scope.graphShow;
        $scope.viewLabel = ($scope.graphShow === true ? "Table view" : "Summary view");
/*
        $(window).resize();
*/
    }

    $backupCopyTargetTable = $("#dashboard-recover-targets")
    var backupCopyTargetTable;
    var dtOptions = {
        select: false,
        multiselect: false,
        /*className: "active-jobs",*/
        /*cellClasses: ["long-text truncate", "long-text truncate", null, null], */
        placeholder: gettext("There are no active Backup Copy Targets")
    };
    
    var cellFormatter = {
        lastTransferred: function(value, row) {
            var strLastTransferred = row.lastTransferred;
            return '<div style="text-align:center;">' + strLastTransferred + '</div>';
        },
        avgSpeed: function(value, row) {
            var strAvgSpeed = row.avgSpeed;
            return '<div style="text-align:center;">' + strAvgSpeed + '</div>';
        },
        errors:function(value, row) {
            var strErrors = row.errors;
            return '<div style="text-align:center;">' + strErrors + '</div>';
        }
    }
    
    $scope.backupCopyProtected=12;
    $scope.backupCopyErrors=1;
	$scope.$on('dialogopenEvent', function (event, widget,index){
         if(widget.name === 'BACKUP COPY - TARGET'){
            $scope.toggleModal();
             $("[id='id_backup copy targetRefresh']").val($rootScope.listOfTimer[9]/1000);
			event.defaultPrevented = true;
        }
    });
    /* Event listener for manual;Refesh */
	$scope.$on('manualRefreshEvent', function (event, widget,index){
     if(widget.name === 'BACKUP COPY - TARGET'){
		$rootScope.getBackupCopyTargetRefereshData();
		event.defaultPrevented = true;
		    
        }
    });
    
    $rootScope.getBackupCopyTargetRefereshData = function(days){
         $http({
            method: 'GET',
            url: '/api/summary/counts/replicated_backup'
        }).success(function(data, status, headers) {
            //var timestamp=data.timestamp *1000;
            $scope.timeStamp = data.last_updated;//getDateString(timestamp);
            $scope.errors=data.replicated_backup_errors;
            $scope.protected=data.replicated_backup_protected;
        }).error(function(data, status, headers) {
            console.log('api_summary_days_replication_error');
        });
	}
    
    $scope.getBackupCopyTargetAverageSpeed = function(days){
        var total=0,
            days =days||7,
            url ='/api/summary/target-days/?days='+days;
        
        backupCopyTargetTable = PHD.DataTable($backupCopyTargetTable, dtOptions).registerFormatters(cellFormatter);
                
        $http({
            method: 'GET',
            url: url
        }).success(function(data, status, headers) {
            var avgSpeedArray=[];
            var averageSize=0;
            var dataArray=[];
            var daysArray=[];
            var count =0;
            console.log(data.data);
            
            /*   START: For Graph View    */
             for (var i =0 ; i < 7; i++){
                 for ( key in data.data){
                    if (i == 0){
                      $scope.units=data.data[key][1].replicating_size[i].units;
                     } 
                     count++;
                   console.log(key);
                  averageSize+=   data.data[key][1].replicating_size[i].write;
                   daysArray[i]= data.data[key][1].replicating_size[i].day.substring(5,data.data[key][1].replicating_size[i].day.length).replace("-","/");
                 }
                   averageSize =(count != 0)? (averageSize/7):0;
                   dataArray[i]=averageSize.toFixed(2);
                   
                  
		  }
          $scope.dataValues=[dataArray];
          $scope.daysArray=daysArray;
          $scope.maxvalue=Math.max.apply(Math,dataArray);
          $scope.maxValuewithUnits=$scope.maxvalue+$scope.units;
           console.log($scope.units);
          var avgspeed_width = $('#backup-copy-target-graph-avgspeed').width();
          var raph_avgspeed=Raphael('backup-copy-target-graph-avgspeed',"100%","100%");
          plotBarGraph_BackupWidget(raph_avgspeed, $scope.dataValues, $scope.units,$scope.daysArray,$scope.colorArray,     $scope.legends, $scope.maxValuewithUnits,$scope.maxvalue,avgspeed_width);
            
          $(window).resize();
        /*   END: For Graph View    */
            
        /*   START: For Table View    */
            var tempBackupCopyTargetArr = [];
            var totalOfAvgReplicatingSpeed=0;
            var totalAppliance = 0;
            $scope.replicatingSpeedUnits="MB/s";
            
            for(key in data.data){
                var backupCopyTargetObj = {};
                var replicatingSpeed = 0;
                $scope.replicatingSpeedUnits=data.data[key][0].replicating_speed[0].units;
                
                totalAppliance += 1;
                backupCopyTargetObj.sourceName = key;
                backupCopyTargetObj.errors = 0;
                backupCopyTargetObj.lastTransferred = (data.data[key][0].replicating_speed[6].write) + ' ' + $scope.replicatingSpeedUnits;
                
                for(var i=0;i<7;i++){
                    replicatingSpeed += data.data[key][0].replicating_speed[i].write;
                }
                backupCopyTargetObj.avgSpeed = (replicatingSpeed/7).toFixed(2) + ' ' + $scope.replicatingSpeedUnits;
                totalOfAvgReplicatingSpeed += (replicatingSpeed/7);
                
                tempBackupCopyTargetArr.push(backupCopyTargetObj);
            }
            $scope.averageReplicatingSpeed = (totalAppliance === 0) ? 0 : (totalOfAvgReplicatingSpeed / totalAppliance).toFixed(2);
            
            $scope.backupCopyTargetTableArray = tempBackupCopyTargetArr;
            backupCopyTargetTable.load($scope.backupCopyTargetTableArray);
            
        /*   END: For Table View    */
            
        }).error(function(data, status, headers) {
            console.log('api_summary_days_replication_error');
        });
	
	}
    
    
   $(window).on("resize", function(event){
		    if ($scope.reSizeGraph == true){
               var avgspeed_width = $('#backup-copy-target-graph-avgspeed').width();
              $('#backup-copy-target-graph-avgspeed').empty();
			  var raph_avgspeed=Raphael('backup-copy-target-graph-avgspeed',"100%","100%");
              plotBarGraph_BackupWidget(raph_avgspeed, $scope.dataValues, $scope.units,$scope.daysArray,$scope.colorArray,     $scope.legends, $scope.maxValuewithUnits,$scope.maxvalue,avgspeed_width);
            }
	});
    $scope.userPrefernce = function(){
        $rootScope.manualRefreshControl($rootScope.listOfTimer[9]/1000,$scope.widgetName);
    }
    if ($scope.user.loggedIn) {
        $scope.userPrefernce();
        $rootScope.getBackupCopyTargetRefereshData();
        $scope.getBackupCopyTargetAverageSpeed();
    }
    $(document)
                .on("login", function(event) {
                    stopAll();
                })
                .on("logout", function(event) {
                    stopAll();
                })
                .on("uinav.dashboard", function(event) {
					stopAll();
                })
                .on("uinav.protect", function(event) {
                    stopAll();
                })
                .on("uinav.recover", function(event) {
                    stopAll();
                })
                .on("uinav.jobs", function(event) {
                    stopAll();
                })
                .on("uinav.configure", function(event) {
                    stopAll();
                })
                .on("uinav.reports", function(event) {
                    stopAll();
     });
     function stopAll() {
                clearInterval($rootScope.listOfTimerFunction[9]);
			    $scope.reSizeGraph=false;
                $(document).off("login");
                $(document).off("logout");
                $(document).off("uinav");
                delete $(document);
	}
   
});