var virtual_id;
var wirMode;
var jobType;
var sid;
var virtualId = 0;
var virtualType = "";
var hypervisorType = "";
var mode = "";
var liveTime = "";
var backupUrl="";
var detailUrl = "";
var vmName ="";
var app_type = "";
var selectedBackup = {};
var selectedNodeDataArray = [];
			


function processRecoverPage(PHD, window, $rootScope, $analytics, $scope) {
    var isWirJob = false;  
    var tabs = [],
        initialTab = $.cookie("initial_tab_recover") || 0,
        currentTabIndex = 0,
        backupCatalog, backupFilter,
        pageRefresh = null,
        $backupCatalog = $("#recover-backup-table"),
        $backupFilter = $("#recover-backup-catalog-filter"),
        backupSelections,
        backupCatalogView = BACKUP_CATALOG_VIEW_VM,
        // lmc - change back to original (VM view)
        //backupCatalogView = BACKUP_CATALOG_VIEW_DATE,
        RECOVER_TAB_BACKUPS = 0,
        RECOVER_TAB_FLR = 1,
        RECOVER_TAB_IR = 2,
        DETAIL_TABLE_HEIGHT = 250,
        slugs = ['backups', 'flr', 'ir'],
        $flrTable = $("#recover-flr-table"),
        flrTreeTable,
        $flrTableMessage = $("#recover-flr-table-message"),
        $irTableMessage = $("#recover-ir-table-message");

    // lmc - add this.
    var RecoverTimer = $rootScope.RecoverTimer;

    var options = {};
    options[BACKUP_CATALOG_VIEW_VM] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: false, expandonselect: true},
        2: {multiselect: true, childselect: false}
    };
    options[BACKUP_CATALOG_VIEW_DATE] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: "all", expandonselect: true},
        2: {multiselect: true, childselect: false, expandonselect: true},
        3: {multiselect: true, childselect: false}
    };
    options[BACKUP_CATALOG_VIEW_BDS] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: "all", expandonselect: true},
        2: {multiselect: true, childselect: false, expandonselect: true},
        3: {multiselect: true, childselect: false}
    };

    options[BACKUP_CATALOG_VIEW_APPLIANCE] = {
        view: backupCatalogView,
        0: {multiselect: true, childselect: "all", expandonselect: true},
        1: {multiselect: true, childselect: "all", expandonselect: true},
        2: {multiselect: true, childselect: false, expandonselect: true},
        3: {multiselect: true, childselect: false}
    };

    $(document).on("ajaxaborted ajaxtimeout", function () {
        if (pageRefresh !== null) {
            clearInterval(pageRefresh);
        }
    });

    $(document)
        .on("timertick.recoverpage", $.proxy(refreshPage, this));

    $(document)
        .on("uinav.dashboard", function (event) {
            console.log("=====>Selected Dashboard");
            stopAll();
        })
        .on("uinav.protect", function (event) {
            console.log("=====>Selected Protect");
            stopAll();
        })
        .on("uinav.recover", function (event) {
            console.log("=====>Selected Recover");
        })
        .on("uinav.jobs", function (event) {
            console.log("=====>Selected Jobs");
            stopAll();
        })
        .on("uinav.configure", function (event) {
            console.log("=====>Selected Configure");
            stopAll();
        })
        .on("uinav.reports", function (event) {
            console.log("=====>Selected Reports");
            stopAll();
        });


    $backupFilter.on("needMoreData",function(event,ui) {
        updateCatalog(true);
    });

    function stopAll() {
        RecoverTimer.stop();
        $(document).off("timertick.recoverpage");
        delete $(document);
    }

    function refreshPage(manual) {
        var manual = (manual === true),
            tab = tabs[currentTabIndex];
        if (manual) {
            tab.update(manual);
        } else {
            tab.update(false);
        }
    }

    function resizeTable() {
        this.adjustTableHeight(this.getAvailableVerticalSpace(".full-height"));
        this.adjustTableWidth();
    }

    function initTabs() {
        $(".ui-tabs-panel").each(function (index) {
            tabs[index] = new RecoverTab(index, $(this));
            tabs[index].initButtons();

            if (index === RECOVER_TAB_BACKUPS) {
                initBackupsTab(tabs[index]);
            } else if (index === RECOVER_TAB_FLR) {
                initFLRTab(tabs[index]);
            } else if (index === RECOVER_TAB_IR) {
                initIRTab(tabs[index]);
            }
        });

    }

    var IRFormatter = {
		type:function (value, row) {
			console.log(value);
			var icon_name="";
			var title="";
		 	if(value == "wir"){
			    icon_name = "instant-recover" ;	
				title="Windows Instant Recovery";
			}else if(value == "vm_ir"){
			    icon_name = "backup" ;
				title="VM Instant Recovery";
			}else{
			    icon_name = "backup" ;
			    title="HV Instant Recovery";
			}
			var icon = '<i class="icon-uui-' + icon_name + ' icon-large" title="' + title + '"></i>';
                return icon;
		},
        alert: function (value, row) {
            var icon = "";
            if (value != "") {
                icon = '<i class="icon-warningsign icon-large" title="' + value + '"></i>';
                $('id_alert').show();
            } else {
                $('id_alert').hide();
            }
            return icon;
        }
        /*backup_info: function (value, row) {
            return moment(value).zone(tz).format("M/D/YYYY h:mmA")
        },
        write_space_used: function (value, row) {
            return PHD.util.formatBytes(value);
        },
        started: function (value, row) {
            return moment(value).zone(tz).format("M/D/YYYY h:mmA")
        } */
    };

    var IRDetailsFormatter = {
        comment: function (value, row) {
            return '<span class="truncates item-name" title="' + value + '">' + value + '</span>';
        }
    };

    function initIRTab(tab) {
        tab.$details = tab.$panel.find(".job-detail").hide();

        tab.$sessionTable = tab.$panel.find("#ir-session-table");
        tab.$lastBackupTable = tab.$panel.find("#id_last_backup_table");
        tab.$pendingBackupTable = tab.$panel.find("#id_pending_backup_table");
        //tab.$jobTable = tab.$panel.find("#ir-session-jobs-table");

        tab.$selected = $();
        tab.selectedID = null;

        tab.$selectedJob = $();
        tab.selectedJobID = null;
        tab.rowData = null;

        tab.SessionTable = PHD.DataTable(tab.$sessionTable, {
            select: true,
            placeholder: gettext("There are no active Instant Recovery VMs"),
            sortable: true,
            integerIDs: false   //lmc - e.g., 65.ir
        }).registerFormatters(IRFormatter);

        tab.LastBackupTable = PHD.DataTable(tab.$lastBackupTable, {
            select: true,
            placeholder: gettext("There are no completed restores"),
            sortable: true,
            integerIDs: false
        });

        tab.PendingBackupTable = PHD.DataTable(tab.$pendingBackupTable, {
            select: true,
            placeholder: gettext("There are no pending restores"),
            sortable: true,
            integerIDs: false
        });

        /*tab.JobTable = PHD.DataTable(tab.$jobTable, {
            select: true,
            placeholder: gettext("There are no jobs to display"),
            sortable: false,
            cellClasses: [null, null, null, "long-text truncate"]
        }).registerFormatters(IRDetailsFormatter);*/

        tab.timestamp = 0;
        tab.inventoryTimestamp = 0;
        tab.inventoryOpen = false;

        tab.$sessionTable.on("rowselect", function (event, dbid, $row, DataTable, DataRow) {
           wirMode = DataTable.data[$row.context.sectionRowIndex].mode;
           jobType = DataTable.data[$row.context.sectionRowIndex].type;
           virtual_id = DataTable.data[$row.context.sectionRowIndex].virtual_id;
           sid = DataTable.data[$row.context.sectionRowIndex].sid;
            $("#tearDownBtnId").removeClass("disabled");
            if(DataTable.data[$row.context.sectionRowIndex].type === "wir"){
                isWirJob = true;
                virtualId = 0;
                virtualType = "";
                virtualId = DataTable.data[$row.context.sectionRowIndex].virtual_id;
                virtualType = DataTable.data[$row.context.sectionRowIndex].type;
                hypervisorType = DataTable.data[$row.context.sectionRowIndex].hypervisor_type;
                mode = DataTable.data[$row.context.sectionRowIndex].mode;
				vmName = DataTable.data[$row.context.sectionRowIndex].vm_name;
                if (DataTable.data[$row.context.sectionRowIndex].hasOwnProperty('live_time')) {
                    liveTime = DataTable.data[$row.context.sectionRowIndex].live_time;
                }
                $("#editIRBtn").removeClass("disabled");
                
            }else {
                isWirJob = false;
                $("#editIRBtn").addClass("disabled");
            }

            tab.$selected = $row;
            tab.selectedID = dbid;
            tab.rowData = DataRow.data;
            tab.updateButtons();

            detailUrl = "";
            detailUrl = "/api/virtual_clients/" + virtual_id + "/details/?type=" + jobType +"&sid=" + sid,
                updateDetails = PHD.Ajax.get(detailUrl);

            updateDetails.done(function(data) {
                updateDetailedInfo(data, tab);
            });

            if (tab.inventoryOpen) {
                tab.showJobDetails();
            }
        });

        tab.showJobDetails = $.proxy(showIRJobs, tab);
        tab.hideJobDetails = $.proxy(hideIRJobs, tab);
        tab.updateJobs = $.proxy(updateIRJobs, tab);
    }

    /*
     * Updates detailed info in bottom of IR tab.
     */
    var updateDetailedInfo = function(data, tab) {
        if(data.hasOwnProperty('type') && data.type !== "wir") {
            isWirJob = false;
            $('#id_vir_vc_name').text("");
            $('#id_vir_vc_created').text("");
            $('#id_vir_vc_duration').text("");
            $('#id_vir_vc_sname').text("");
            $('#id_vir_vc_message').text("");

            $('#id_vir_vc_name').text(data.vm_name);
            $('#id_vir_vc_created').text(data.created);
            $('#id_vir_vc_duration').text(data.duration);
            $('#id_vir_vc_status').text(data.status);
            $('#id_vir_vc_message').text(data.comment);

            tab.LastBackupTable.update(data.last, true);
            tab.PendingBackupTable.update(data.pending, true)

        } else {
            isWirJob = true;
            backupUrl="";
            backupUrl = "/api/virtual_clients/"+ virtual_id +"/backup_history/?sid=" + sid;
            var  updateBackups = PHD.Ajax.get(backupUrl);
            updateBackups.done(function (data) {
                console.log(data);
                tab.LastBackupTable.update(data.last, true);
                tab.PendingBackupTable.update(data.pending, true);
            });

            $('#id_wir_vc_name').text("");
            $('#id_wir_vc_processors').text("");
            $('#id_wir_vc_memory').text("");

            $('#id_wir_vc_name').text(data.virtual_client.vm_name);
            $('#id_wir_vc_processors').text(data.virtual_client.processors);
            $('#id_wir_vc_memory').text(data.virtual_client.memory);
            var included_volumes = "";
            var delim = "";
            for (var i = 0; i < data.virtual_client.included_volumes.length; i++) {
                included_volumes += delim + data.virtual_client.included_volumes[i];
                delim = ", ";
            }
            $('#id_wir_vc_incvolumes').text(included_volumes);
            if ("excluded_volumes" in data.virtual_client) {
                $('#id_wir_excvolumes_label').show();
                var excluded_volumes = "";
                var delim = "";
                for (var j = 0; j < data.virtual_client.excluded_volumes.length; j++) {
                    excluded_volumes += delim + data.virtual_client.excluded_volumes[j];
                    delim = ", ";
                }
                $('#id_wir_vc_excvolumes').text(excluded_volumes);
            } else {
                $('#id_wir_excvolumes_label').hide();
                $('#id_wir_vc_excvolumes').text('');
            }
            if ("port" in data.virtual_client) {
                $('#id_wir_port_label').show();
                $('#id_wir_port').text(data.virtual_client.port);
            } else {
                $('#id_wir_port_label').hide();
                $('#id_wir_port').text('');
            }
        }
    };

    var updateIRJobs = function (reset, sessionID) {
        if (this.inventoryOpen && this.selectedID && this.selectedID === sessionID) {
            //var load = reset ? PHD.showLoadingIndicator(this.$details) : null;
            var self = this;
            /*var url = "/api/jobs/active/ir/" + sessionID + '/';

            var request = PHD.Ajax.get(url, load);

            request.done(function (data) {
                //PHD.hideLoadingIndicator(load);
                var irs = data.data;
                if (irs !== undefined && Array.isArray(irs)) {
                    irs.forEach(function (ir, index) {
                        if (ir.id == self.selectedID) {
                            self.inventoryTimestamp = data.timestamp;
                            var ir_array = [ ir ];
                            if (reset) {
                                self.JobTable.load(ir_array);
                            } else {
                                self.JobTable.update(ir_array, true);
                            }
                            self.$jobTable.scrollTable({"height": DETAIL_TABLE_HEIGHT});

                            self.updateButtons();
                        }
                    });
                }
            });*/
            var detailUrl = "/api/virtual_clients/" + virtual_id + "/details/?type=" + jobType +"&sid=" + sid,
                updateDetails = PHD.Ajax.get(detailUrl);

            updateDetails.done(function(data) {
                updateDetailedInfo(data, self);
                self.updateButtons();
            });
        }
    };

    var showIRJobs = function () {
        this.inventoryTimestamp = 0;
        if (this.$details.is(":hidden")) {
            this.$sessionTable
                .adjustTableHeight(this.$sessionTable.getAvailableVerticalSpace(".full-height") - DETAIL_TABLE_HEIGHT);
            if(isWirJob) {
                $( "#virTabs" ).hide();
                $( "#wirTabs" ).show();
            } else {
                $( "#virTabs" ).show();
                $( "#wirTabs" ).hide();
            }
            this.$details.show("slide", {direction: "down"});
            this.inventoryOpen = true;
            this.updateJobs(true, this.selectedID);
        } else {
            if(isWirJob) {
                $( "#virTabs" ).hide();
                $( "#wirTabs" ).show();
            } else if(!isWirJob){
                $( "#virTabs" ).show();
                $( "#wirTabs" ).hide();
            }
            this.updateJobs(true, this.selectedID);
        }
        this.updateButtons();
    };

    var hideIRJobs = function () {
        var self = this;
        this.$details.hide("slide", {direction: "down"}, function () {
            self.$sessionTable
                .adjustTableHeight(self.$sessionTable.getAvailableVerticalSpace(".full-height"));
            self.inventoryOpen = false;
            self.updateButtons();
        });
    };

    function initBackupsTab(tab) {
        backupCatalog = PHD.BackupCatalog($backupCatalog, options[backupCatalogView]);
        backupFilter = PHD.BackupFilter($backupFilter, backupCatalog);

        initFilters();

        backupCatalog.$table
            .on("treeselect", ".row-select", function (node, checked, self) {
                backupSelections = backupCatalog.getSelections();
                selectedNodeDataArray = backupCatalog.getSelectedNodes(["backup_id", "archive_id"]);
                console.log(selectedNodeDataArray);

                var $selected = backupCatalog.$table.find(".row-select:checked").closest("tr");

                var lastSelectedRowData = selectedNodeDataArray[selectedNodeDataArray.length-1];

                if(selectedNodeDataArray && selectedNodeDataArray.length > 0) {
                    app_type = lastSelectedRowData.getAttribute("app-type");
                    selectedBackup.instance_id = lastSelectedRowData.getAttribute("instance-id") != undefined ? lastSelectedRowData.getAttribute("instance-id") : lastSelectedRowData.getAttribute("data-id");
                    selectedBackup.client_id = lastSelectedRowData.getAttribute("client-id") != undefined ? lastSelectedRowData.getAttribute('client-id') : "";
                    selectedBackup.backup_id = lastSelectedRowData.getAttribute("backup_id");
                    selectedBackup.archive_id = lastSelectedRowData.getAttribute("archive_id");
                    selectedBackup.sid = lastSelectedRowData.getAttribute("system-id");
                    selectedBackup.local_system_id = lastSelectedRowData.getAttribute("local-system-id");
                    selectedBackup.replicated = lastSelectedRowData.getAttribute("replicated");
                    selectedBackup.app_id = lastSelectedRowData.getAttribute("app-id");
                    selectedBackup.starttime_backup = moment(lastSelectedRowData.getAttribute("data-date")).format("MM/DD/YYYY");

                    if (selectedBackup.archive_id != null || $selected.length != 1 ) {
                        $('#restoreBtn').addClass("disabled");
                    } else {
                        $('#restoreBtn').removeClass("disabled");
                    }

                    if (selectedBackup.backup_id != null) {
                        var url = "/api/backups/?sid=" + ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid)
                            + "&bid=" + selectedBackup.backup_id + "&end_date=" + selectedBackup.starttime_backup;
                        PHD.Ajax
                            .get(url)
                            .done(function(data) {
                                if (data.BackupStatus !== undefined && Array.isArray(data.BackupStatus)) {
                                    data = data.BackupStatus[0];
                                    selectedBackup.vm_name = (data.vm_name != null) ? data.vm_name : (data.database_name != null) ? data.database_name : data.client_name;
                                    selectedBackup.vmware_template = data.vmware_template !== undefined && data.vmware_template;
                                    selectedBackup.synth_capable = (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER && data.synth_capable !== undefined && data.synth_capable != null) ? data.synth_capable : false;
                                    selectedBackup.backup_size = data.size;
                                    selectedBackup.backup_date = data.start_time;
                                    selectedBackup.datbase_name =  data.database_name;
                                    selectedBackup.server_instance_name = data.server_instance_name;
                                    selectedBackup.backup_type =  data.type;
                                    selectedBackup.client_name = data.client_name;
                                    selectedBackup.client_os = data.client_os;
                                }
                                if ((selectedBackup.vmware_template !== undefined && selectedBackup.vmware_template) || (app_type !== APPLICATION_TYPE_NAME_HYPER_V && app_type !== APPLICATION_TYPE_NAME_VMWARE)) {
                                    $('#irBtn').addClass("disabled");
                                    $('#vmIRBtn').addClass("disabled");
                                } else {
                                    $('#irBtn').removeClass("disabled");
                                    $('#vmIRBtn').removeClass("disabled");
                                }
                                if ((selectedBackup.vmware_template !== undefined && selectedBackup.vmware_template) || $selected.length != 1 || app_type === APPLICATION_TYPE_NAME_SQL_SERVER ||
                                    (selectedBackup.app_id != 1 && selectedBackup.archive_id != null) || Number(selectedBackup.app_id) === APP_ID_CISCO_UCS_SERVICE_PROFILE ) {
                                    $('#restoreFilesBtn').addClass("disabled");
                                } else {
                                    $('#restoreFilesBtn').removeClass("disabled");
                                }
                                // Disable restore button for iSeries.  Allow restore files for browsing.
                                if (selectedBackup.client_os === "iSeries") {
                                    $('#restoreBtn').addClass("disabled");
                                }
                            });
                    } else {
                        var aurl = "/api/archive/status/?sid=" + ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid);
                        var idJSON = { 'archive_ids': [parseInt(selectedBackup.archive_id, 10)]};
                        idJSON = JSON.stringify(idJSON);
                        PHD.Ajax
                            .post(aurl, idJSON)
                            .done(function(data) {
                                if (data.status !== undefined && Array.isArray(data.status)) {
                                    data = data.status[0];
                                    selectedBackup.vm_name = (data.vm_name != null) ? data.vm_name : (data.database_name != null) ? data.database_name : data.client_name;
                                    selectedBackup.vmware_template = data.vmware_template !== undefined && data.vmware_template;
                                    selectedBackup.synth_capable = (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER && data.synth_capable !== undefined && data.synth_capable != null) ? data.synth_capable : false;
                                    selectedBackup.backup_size = data.size;
                                    selectedBackup.backup_date = data.backup_date;
                                    selectedBackup.datbase_name =  data.database_name;
                                    selectedBackup.server_instance_name = data.server_instance_name;
                                    selectedBackup.backup_type =  data.type;
                                    selectedBackup.client_name = data.client_name;
                                    selectedBackup.client_os = data.os_type;
                                }
                                if ((selectedBackup.vmware_template !== undefined && selectedBackup.vmware_template) || $selected.length != 1 || app_type === APPLICATION_TYPE_NAME_SQL_SERVER ||
                                    (selectedBackup.app_id != 1 && selectedBackup.archive_id != null) || Number(selectedBackup.app_id) === APP_ID_CISCO_UCS_SERVICE_PROFILE || app_type === APPLICATION_TYPE_NAME_NDMP_DEVICE ) {
                                    $('#restoreFilesBtn').addClass("disabled");
                                } else {
                                    $('#restoreFilesBtn').removeClass("disabled");
                                }
                            });
                    }
                } else {
                    $('#restoreBtn').addClass("disabled");
                    $('#restoreFilesBtn').addClass("disabled");
                    $('#irBtn').addClass("disabled");
                    $('#vmIRBtn').addClass("disabled");
                    selectedBackup.local_system_id = $selected.attr('local-system-id');
                    selectedBackup.replicated = $selected.attr('replicated');
                    console.log("<< selected backup "  + selectedBackup.local_system_id);
                }
			
                tab.$buttons.find("a").each(function () {
                    var $but = $(this);
                    $but.data("selections", backupSelections);
                    PHD.buttonLogic($but, $selected, tab, null, null, {provider: $analytics, source: 'Recover'});
                });
            })
            .on("backupcatalogloadchildren", function () {
                $(this).scrollTable({"height": "article"});
            });
        tab.TreeTable = backupCatalog;
		selectedNodeDataArray = [];
    }

    function update(tab, init) {
        init = (init === true);
        if (tab.index === RECOVER_TAB_BACKUPS) {
            updateCatalog(init);
        } else if (tab.index === RECOVER_TAB_FLR) {
            updateFLR(init, tab);
        } else if (tab.index === RECOVER_TAB_IR) {
            updateIR(init, tab);
        }
        tab.updateButtons();
    }

    function updateIR(init, tab) {
        var url = "/api/virtual_clients/",
            update = PHD.Ajax.get(url);

        update.done(function (data) {
            if (data.timestamp === tab.timestamp) {
                tab.timestamp += 1;
            } else {
                tab.timestamp = data.timestamp;
            }

            var irData = formatIRData(data.data);
            $scope.$apply(function() {
                $scope.irTableData = Array.isArray(irData) && irData.length > 0;
            });
            tab.SessionTable.load(irData);
            tab.$sessionTable.scrollTable();
            RecoverTimer.stop();
            RecoverTimer.start();

            tab.updateJobs(false, tab.selectedID);

            $(window)
                .off("resize.ir")
                .on("resize.ir", PHD.util.debounce($.proxy(resizeTable, tab.$sessionTable)));

            tab.updateButtons();
        });
    }

    function formatIRData(data) {
        var virtual_clients_data = [];
        for (var i = 0; i < data.length; i++) {
             var sid = data[i].system_id;
			 var appliance_name = data[i].system_name;
            if(data[i].hv_ir){
                if ("data" in data[i].hv_ir) {
                    var hv_ir_data = data[i].hv_ir.data;
                    if (hv_ir_data.length > 0) {
                        for (var j = 0; j < hv_ir_data.length; j++) {
                            hv_ir_data[j].id = hv_ir_data[j].virtual_id;
                            hv_ir_data[j].sid = sid;
							hv_ir_data[j].appliance_name = appliance_name;
							hv_ir_data[j].type = hv_ir_data[j].type;
                            hv_ir_data[j].alert = "";
                            virtual_clients_data.push(hv_ir_data[j]);
                        }
                    }
                }
            }
            if(data[i].vm_ir){
                if ("data" in data[i].vm_ir) {
                    var vm_ir_data = data[i].vm_ir.data;
                    if (vm_ir_data.length > 0) {
                        for (var k = 0; k < vm_ir_data.length; k++) {
                            vm_ir_data[k].id = vm_ir_data[k].virtual_id;
                            vm_ir_data[k].sid = sid;
							vm_ir_data[k].appliance_name = appliance_name;
							vm_ir_data[k].type = vm_ir_data[k].type;
                            vm_ir_data[k].alert = "";
                            virtual_clients_data.push(vm_ir_data[k]);
                        }
                    }
                }
            }
            if(data[i].wir){
                if ("data" in data[i].wir) {
                    var wir_data = data[i].wir.data;
                    if (wir_data.length > 0) {
                        for (var l = 0; l < wir_data.length; l++) {
                            wir_data[l].id = wir_data[l].virtual_id;
                            wir_data[l].sid = sid;
                            wir_data[l].appliance_name = appliance_name;
                            wir_data[l].type = wir_data[l].type;
                            wir_data[l].mode = wir_data[l].mode === 'audit-rdr' ? 'audit' : wir_data[l].mode;
                            if ("pending_state" in wir_data[l]) {
                                wir_data[l].pending_state = wir_data[l].pending_state === 'audit-rdr' ? 'audit' : wir_data[l].pending_state;
                                wir_data[l].mode += "(pending: " + wir_data[l].pending_state + ")";
                            }
                            if ("grandclient" in wir_data[l]) {
                                if (wir_data[l].grandclient) {
                                    if("vm_name" in wir_data[l]) {
                                        wir_data[l].vm_name = wir_data[l].vm_name + COPIED_ASSET;
                                    }
									wir_data[l].appliance_name = wir_data[l].system_name;
                                }
                            }
                            if (wir_data[l].hypervisor_type === HYPERVISOR_UNITRENDS_APPLIANCE) {
                                wir_data[l].server_name = HYPERVISOR_UNITRENDS_APPLIANCE;
                            } else {
                                wir_data[l].server_name = wir_data[l].server_name;
                            }
                            wir_data[l].alert = "";
                            if (wir_data[l].valid) {
                                if (wir_data[l].mode === MODE_HALTED) {
                                    wir_data[l].alert = "This client is halted. If this persists, ";
                                    if (wir_data[l].hypervisor_type === HYPERVISOR_UNITRENDS_APPLIANCE) {
                                        wir_data[l].alert += "reduce allocation of virtual processors and memory or increase virtual failover storage.";
                                    } else {
                                        wir_data[l].alert += "check network connectivity between the Unitrends system and the IP address, " +
                                                        wir_data[l].ip_address + ".";
                                    }
                                }
                            } else {
                                if (wir_data[l].live_time && wir_data[l].live_time !== "") {
                                    wir_data[l].alert = "This client is marked invalid, since it first went live on " + wir_data[l].live_time + ".";
                                } else {
                                    wir_data[l].alert = "This client is invalid; please see the Alerts or Recovery Report for more details.";
                                }
                            }
                            virtual_clients_data.push(wir_data[l]);
                        }
                    }
                }
            }
        }
        return virtual_clients_data;
    }

    function updateCatalog(init) {
        if (init) {
            var startDate = backupFilter.getStartDate();
            var endDate = backupFilter.getEndDate();
            var load_level = backupFilter.getLoadLevel();
            console.log(startDate);
            console.log(endDate);

            var selections = backupCatalog.getSelectionObject(),
                load = PHD.showLoadingIndicator($backupCatalog.parent()),
                task = PHD.BackupCatalogBuilder({
                    "view": backupCatalogView,
                    "checked": selections,
                    "loader": load,
                    "start_date": startDate,
                    "end_date": endDate,
                    "load_level": load_level
                });

            task
                .done(function (data) {
                    $scope.catalogDataStart = startDate != null ? startDate : moment().subtract(1, 'w').format('MM/DD/YYYY');
                    $scope.catalogDataEnd = endDate != null ? endDate : moment().subtract().format('MM/DD/YYYY');

                    backupFilter.setDataRange($scope.catalogDataStart, $scope.catalogDataEnd);
                    backupFilter.setLoadLevel(load_level);
                    updateBackupsTable(data);
                    tabs[currentTabIndex].updateButtons();
                })
                .always(function () {
                    PHD.hideLoadingIndicator(load);
                });
        } else {
            console.log("BC inc update");
            // TODO: Backup Catalog incremental update?
        }
    }

    function updateBackupsTable(data) {
        backupCatalog.load(data);
        backupCatalog.refresh(options[backupCatalogView]);
        backupFilter.refresh(data.tree).submitFilter();
    }

    function updateFLR(init, tab) {
        var url = "/api/jobs/active/flr/";
        var update = PHD.Ajax.get(url);
        update.done(function (data) {
            $scope.$apply(function() {
                $scope.flrTableData = Array.isArray(data.data) && data.data.length > 0;
            });
            if (init === true) {
                initFLRTable(data);
                RecoverTimer.stop();
                RecoverTimer.start();
            } else {
                var ids = tab.getFLRIds();
                updateFLRTable(data, ids);
                RecoverTimer.resume();
            }
        });
    }

    var flrTmpl = _.template(
        '<% for (var i = 0; i < data.length; i++) { %>' +
            '<% var flr = data[i]; %>' +
            '<% flr.iSCSI = (flr.available_targets !== null && flr.available_targets.indexOf("iscsi") != -1) ? "Yes" : "No"; %>' +
            '<% flr.CIFS = (flr.available_targets !== null && flr.available_targets.indexOf("smb") != -1) ? "Yes" : "No"; %>' +
            '<tr data-type="flr" flr_id="<%= flr.id %>" system-id="<%= flr.system_id %>" data-depth="0" class="level-0">' +
            '<td>' +
                '<input type="checkbox" name="flr" id="id_flr_<%= flr.id %>" value="<%= flr.id %>" class="row-select"> ' +
                '<i title="<%= flr.app_title %>" class="<%= flr.icon %> icon"></i>' +
                '<span class="item-name"><%= flr.asset_name %></span>' +
            '</td>' +
            '<td class="job-status-display" data-source="status"><%= flr.status %></td>' +
            '<td data-source="start_date"><%= flr.start_date %></td>' +
            '<td data-source="duration"><%= flr.duration %></td>' +
            '<td data-source="available_targets"><%= flr.iSCSI %></td>' +
            '<td data-source="available_targets"><%= flr.CIFS %></td>' +
            '</tr>' +
        '<% } %>'
    );

    // no checkbox, as no structure
    /*
     '<div class="expand-ctrl"></div>' +
     '<input type="checkbox" name="flr" id="id_flr_<%= flr.id %>" value="<%= flr.id %>" class="row-select"> ' +
     '<i title="Virtual Machine" class="icon-hv-vm icon"></i>' +
     '<span class="item-name"><%= flr.asset_name %></span>' +
     '</td>' +
     '<td data-source="status"><%= flr.status %></td>' +
     '<td data-source="start_date"><%= flr.start_date %></td>' +
     '<td data-source="available_targets"><%= flr.available_targets %></td>' +
     '</tr>' +
     */

    // stuff removed from template
    /*'<% for(var d=0;d<flr.disk.length;d++) { %>' +
     '<% var disk = flr.disk[d]; %>' +
     '<tr data-type="flrdisk" data-depth="1" class="level-1">' +
     '<td>' +
     '<i title="disk" class="icon-hv-drive icon"></i>' +
     '<span class="item-name"><%= disk.data.name %></span>' +
     '<span class="disk-size">(<%= disk.data.total_storage %>)</span>' +
     '</td>' +
     '<td></td>' +
     '<td></td>' +
     '<td></td>' +
     '</tr>' +
     '<% } %>' +
     */

    // if ids are passed in, we could optionally look to add just these.
    function getNewFLR(ids) {
        var html = "",
            url = "/api/jobs/active/flr/",
            update = PHD.Ajax.get(url);

        update.done(function (data) {
            $scope.$apply(function() {
                $scope.flrTableData = Array.isArray(data.data) && data.data.length > 0;
            });
            if (ids !== undefined && ids.length > 0) {
                var new_items = [];
                data.data.forEach(function(obj, index) {
                    ids.forEach(function(id, index) {
                        if (obj.id == id) {
                            new_items.push(obj);
                        }
                    });
                });
                data.data = new_items;
            } else {
                data.objects = data.data;
            }
            //console.log("JSON return on flr is " + JSON.stringify(data.data));
            data = formatFLR(data);
            html = flrTmpl(data) + $flrTable.find("tbody").html();
            $flrTable.find("tbody").html(html);
            $flrTable.scrollTable({"height": "section"});
            flrTreeTable.refresh();
        });
    }

    function initFLRTable(data) {
        data = formatFLR(data);
        $flrTable.find("tbody").html(flrTmpl(data));
        $flrTable.scrollTable({"height": "section"});
        flrTreeTable.refresh();
    }

    function formatFLR(data) {
        var flr_data = {};
        var flr_items = [];
        data.data.forEach(function(obj, index) {
            obj.icon = getFLRIcon(obj.app_type);
            if (obj.app_type ===APPLICATION_TYPE_NAME_HYPER_V || obj.app_type === APPLICATION_TYPE_NAME_VMWARE) {
                obj.app_title = 'Virtual Machine';
            } else {
                obj.app_title = obj.app_type;
            }
            flr_items.push(obj);
        });
        flr_data.data = flr_items;
        return flr_data;
    }

    function getFLRIcon(app_type) {
        var icon = "icon-";
        switch (app_type) {
            case 'VMware':
                icon += "uui-vmware-vm";
                break;
            case 'Hyper-V':
                icon += "uui-hyperv-vm";
                break;
            case 'Exchange':
                icon += "uui-exchange-db";
                break;
            case 'SQL Server':
                icon += "uui-sql-db";
                break;
            case 'SharePoint':
                icon += "uui-sharepoint-db";
                break;
            case 'Oracle':
                icon += "uui-oracle-db";
                break;
            case 'Xen':
                icon += "uui-citrix-vm";
                break;
            default:
                icon += "uui-vm";
                break;
        }
        return icon;
    }

    function updateFLRTable(data, ids) {
        var flrs = data.data,
            create = [];

        flrs.forEach(function (flr, index) {
            var id = flr.id,
                status = flr.status,
                stateTxt = flr.status,
                detailsTxt = flr.share_details,
                durationTxt = flr.duration;

            if (detailsTxt == 'null') {
                detailsTxt = 'None';
            }

            if (!_.contains(ids, id)) {
                create.push(id);
            } else {
                $node = flrTreeTable.getNodeById("flr", id);
                if ($node !== undefined) {
                    $node.find("[data-source=status]").html(stateTxt);
                    $node.find("[data-source=duration]").html(durationTxt);
                    $node.find("[data-source=share_details]").html(detailsTxt);
                }
            }
        });

        if (create.length) {
            getNewFLR(create);
        }
    }

    function initFLRTab(tab) {
        var options = {
            0: {multiselect: false, childselect: "all"}
        }
        flrTreeTable = PHD.TreeTable($flrTable, options);

        flrTreeTable.$table.on("treeselect", ".row-select", function (event, $row, checked) {
            var queryString = flrTreeTable.getSelections();

            if (!checked) {
                $row = null;
            }

            tab.$buttons.find("a").each(function () {
                var $but = $(this);
                $but.data("selections", queryString);
                PHD.buttonLogic($but, $row, tab, null, null, {provider: $analytics, source: 'Recover'});
            });
        });

        tab.TreeTable = flrTreeTable;
        //updateFLR();
    }

    var RecoverTab = function (index, panel) {
        this.index = index;
        this.$panel = panel;
        this.$buttons = this.$panel.find(".button-bar");
        this.$buttons.find(".btn-group-recover").flyout();
    };

    RecoverTab.prototype.update = function (init) {
        update(this, init);
    };

    RecoverTab.prototype.initButtons = function () {
        var tab = this;

        this.$buttons.find("a").each(function (index) {
            var $but = $(this);
            $but.data("selections", null);
            $but.data("catalog-view", backupCatalogView);
            PHD.buttonLogic($but, null, tab, null, null, {provider: $analytics, source: 'Recover'});
        });
    };

    RecoverTab.prototype.updateButtons = function ($button) {
        var $rows,
            tab = this,
            $catalog = tab.index === RECOVER_TAB_BACKUPS ? $backupCatalog : $flrTable;

        if ($button !== void 0) {
            if (tab.index === RECOVER_TAB_IR) {
                PHD.buttonLogic($button, $row, tab, null, tab.rowData, {provider: $analytics, source: 'Recover'});
            } else {
                PHD.buttonLogic($button, $row, tab, null, null, {provider: $analytics, source: 'Recover'});
            }
        } else {
            this.$buttons.find("a").each(function (index) {
                var $but = $(this);
                if (tab.TreeTable !== void 0) {
                    $rows = $catalog.find(".row-select:checked").closest("tr");
                    $but.data("selections", tab.TreeTable.getSelections());
                } else {
                    $rows = tab.$selected;
                    $but.data("selections", "");
                }
                $but.data("catalog-view", backupCatalogView);
                if (tab.index === RECOVER_TAB_IR) {
                    PHD.buttonLogic($but, $rows, tab, null, tab.rowData, {provider: $analytics, source: 'Recover'});
                } else {
                    PHD.buttonLogic($but, $rows, tab, null, null, {provider: $analytics, source: 'Recover'});
                }
            });
        }
    };

    RecoverTab.prototype.getSelections = function () {
        var selections = this.TreeTable.getSelections();
        return selections;
    };

    RecoverTab.prototype.pinRows = function (id, action) {
        var ids = [id];
        if (action === "pin") {
            backupCatalog.pin(ids);
        } else {
            backupCatalog.unpin(ids);
        }

        backupCatalog.deselectAll();
    };

    var backupTmpl = _.template(
        '<table class="backup-list user-backups data-table dashboard-table">' +
        '<thead><tr>' + '<th> </th>' +
        '<th>' + " Host/Server" + '</th><th>' + "Asset" + '</th><th>' + "Type" + '</th><th>' + 'Status' + '</th><th>' + "Date" + '</th>' +
        '</tr></thead><tbody>' +
        '<% for(var i=0;i<data.length;i++) { %>' +
            '<% data[i].client_name = data[i].client_name ; %>' +
            '<% data[i].asset_name = data[i].asset_name; %>' +
            '<tr>' +
            '<td>' +
            '<% if(data[i].gfs_rp_type !== "") { %>' +
                '<div class="help-trigger"><i class="icon-infosign"></i></div>' +
                '<span class="definition">This backup was kept based<br> on a retention policy.</span>' +
            '<% } %>' + '</td>' +
            '<td><span class="truncates"><%= data[i].client_name %></span></td>' +
            '<td><%= data[i].asset_name %></td>' +
            '<td><%= data[i].type %></td>' +
            '<td><%= data[i].status %></td>' +
            '<td><%= data[i].start_time %></td>' +
            '</tr>' +
        '<% } %>' +
        '</tbody></table>'
    );

    var heldBackupTmpl = _.template(
        '<table class="backup-list held-backups data-table dashboard-table">' +
        '<thead><tr>' +
        '<th>' + " Name" + '</th><th>' + "Secondary Name" + '</th><th>' + "Type" + '</th><th>' + "Date" + '</th>' + '<th>' + "Reason" + '</th>' +
        '</tr></thead><tbody>' +
        '<% for(var i=0;i<data.length;i++) { %>' +
        '<% data[i].primary_name = data[i].primary_name == undefined ? (data[i].server_instance_name == undefined ? data[i].client_name : data[i].server_instance_name) : data[i].primary_name; %>' +
        '<% data[i].secondary_name = data[i].secondary_name == undefined ? data[i].database_name : data[i].secondary_name; %>' +
        '<tr>' +
        '<td><span class="truncates"><%= data[i].primary_name %></span></td>' +
        '<td><%= data[i].secondary_name %></td>' +
        '<td><%= data[i].type %></td>' +
        '<td><%= data[i].start_time %></td>' +
        '<td>Held</td>' +
        '</tr>' +
        '<% } %>' +
        '</tbody></table>'
    );


    RecoverTab.prototype.confirmDelete = function (data) {
        var self = this;
        var message = '<h4 class="text-ok">' + "The following backups will be deleted:" + '</h4>';
        var system_id  = selectedBackup.replicated == "true" ? selectedBackup.local_system_id : selectedBackup.sid;    // lmc - TODO for grid.

        // add in original backup info.
        var backups = data.data;

        var holdArray = [];     // backups that are on hold
        var deleteArray = [];   // backups that are not on hold
        var idsArray = [];
        for (var i = 0; i < backups.length; i++) {
            if (backups[i].legalhold == true) {
                holdArray.push(backups[i]);
            } else {
                // Do not return duplicate backup IDs
                if (idsArray.indexOf(backups[i].id) < 0) {
                    idsArray.push(backups[i].id);
                    deleteArray.push(backups[i]);
                }
            }
        }
        var backupsToHold = {};
        backupsToHold.data = holdArray;
        var backupsToDelete = {};
        backupsToDelete.data = deleteArray;

        var deleteBackups = backupsToDelete.data;
        var holdBackups = backupsToHold.data;
        if (backups && backups.length) {
            var backupsHeldMessage = '';
            if (holdBackups && holdBackups.length) {
                backupsHeldMessage += '<h4 class="text-ok">' + "The following backups cannot be deleted:" + '</h4>';
                backupsHeldMessage += heldBackupTmpl(backupsToHold);
            }

            // Both backups that are on hold and those that are not on hold are selected
            if (deleteBackups && deleteBackups.length) {
                ids = _.pluck(deleteBackups, 'id');
                message += backupTmpl(backupsToDelete);
                message += backupsHeldMessage;

                PHD.appliance_sid = system_id;

                confirm = PHD.confirmDialog(
                    message,
                    {
                        title: gettext("Confirm Backup Deletion"),
                        open: function (event, ui) {
                            var $dialog = $(this);
                            $dialog.find("table.data-table").scrollTable({"height": 120, "resize": false});
                            $dialog.find(".ui-dialog-buttonset button:last-child").focus();
                            $dialog.dialog("option", "position", {my: "center", at: "center", of: window});
                            $dialog.find(".definition").popover({
                                appendTo: $dialog,
                                position: {
                                    my: "left-30 bottom",
                                    at: "right bottom+40",
                                    within: $dialog
                                }
                            });
                        }
                    }
                );

                confirm.done(function () {
                    var str_ids = ids.toString();
                    var sid = (PHD.appliance_sid === null) ? "" : "/?sid=" + PHD.appliance_sid;
                    var url = "/api/backups/" + str_ids + sid;
                    var resp = PHD.Ajax.delete(url);

                    resp.done(function(data) {
                        console.log("done with backup deletion, clearing ids: " + str_ids);
                        self.deleteRows('backup', ids);
                        self.updateButtons();
                    });
                    backupCatalog.deselectAll();
                });
            } else {
                // Only backups that are on hold are selected
                if (holdBackups && holdBackups.length) {
                    var option = PHD.dialogs.alert;
                    $("<div/>", {
                        id: "dialog-ajax-error",
                        title: "Error deleting backups",
                        "class": "dialog-box"
                    })
                        .hide()
                        .appendTo("body")
                        .html(backupsHeldMessage)
                        .dialog(option);
                }
            }

        } else {
            message = '<h4 class="text-ok">' + "There are no backups to delete." + '</h4>';
            var options = PHD.dialogs.alert;
            $("<div/>", {
                id: "dialog-ajax-error",
                title: "Error deleting backups",
                "class": "dialog-box"
            })
                .hide()
                .appendTo("body")
                .html(message)
                .dialog(options);
        }
    };

    RecoverTab.prototype.deleteRows = function (node_type, ids) {
         ids.forEach(function (id) {
            backupCatalog.deleteNodeById(node_type, id);
         });
     };

    /*RecoverTab.prototype.deleteRows = function (nodes) {
        nodes.forEach(function (node) {
            backupCatalog.deleteNodeById(node.type, node.id);
        });
    };*/

    RecoverTab.prototype.deleteFLR = function (flr_id) {
        flrTreeTable.deleteNodeById("flr", flr_id);
        $flrTable.scrollTable({"height": "section"});
        flrTreeTable.refresh();
    };

    RecoverTab.prototype.getFLRIds = function () {
        return $flrTable
            .find("[data-type=flr]")
            .map(function () {
                //return parseInt($(this).attr("flr_id"), 10);
                //lmc - not numeric
                return $(this).attr("flr_id");
            })
            .get();
    };

    var flrDetailTmpl = _.template(
        '<table style="font-size:12px;max-width:100%;width:100%;line-height:29px">' +
        '<tr>' +
        '<td style="width:100px">' + '<strong>' + gettext('Name') + '</strong>:' + '</td>' +
        '<td> <%= instance_name %> (<%= application %> VM)' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettext('Host/Server') + '</strong>:' + '</td>' +
        '<td> <%= client_name %> ' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettext('Created') + '</strong>:' + '</td>' +
        '<td> <%= start_date %> ' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettext('Appliance') + '</strong>:' + '</td>' +
        '<td> <%= system_name %> ' + '</td>' +
        '</tr>' +
        '<tr><td>&nbsp;</td></tr>' +
        '<tr>' +
        '<td>' + '<strong>' + gettext('CIFS Path') + '</strong>:' + '</td>' +
        '<td> <%= share_details %> ' + '</td>' +
        '</tr>' +
        '<tr>' +
        '<td style="vertical-align:top">' + '<strong>' + gettext('iSCSI (Windows)') + '</strong>:' + '</td>' +
        '<td style="white-space:normal;word-wrap:break-word;vertical-align:top;line-height:20px;padding-top:6px;"> <%= str_iscsi_win_details %> ' + '</td>' +
        '</tr>' +
        '<tr><td></td></tr>' +
        '<tr>' +
        '<td style="vertical-align:top">' + '<strong>' + gettext('iSCSI (Linux)') + '</strong>:' + '</td>' +
        '<td style="white-space:normal;word-wrap:break-word;vertical-align:top;line-height:20px;padding-top:6px;"> <%= str_iscsi_linux_details %> ' + '</td>' +
        '</tr>' +
        '<tr><td>&nbsp;</td></tr>' +
        '<% if (str_admin_url && str_admin_url != null) { %>' +
            '<tr>' +
            '<td style="vertical-align:top">' + '<strong>' + gettext('Administration URL') + '</strong>:' + '</td>' +
            '<td> <%= str_admin_url %> ' + '</td>' +
            '</tr>' +
            '<tr><td>&nbsp;</td></tr>' +
        '<% } %>' +
        '<tr>' +
        '<td style="vertical-align:top">' + '<strong>' + gettext('Messages') + '</strong>:' + '</td>' +
        '<td style="white-space:normal;word-wrap:break-word;vertical-align:top"> <%= comment %> ' + '</td>' +
        '</tr>' +
        '</table>'
    );

    RecoverTab.prototype.showFLRDetails = function (id, system_id) {
        var resp, options;

        options = {
            modal: true,
            draggable: true,
            resizable: false,
            width: 550,
            height: 400,
            dialogClass: "dialog-flr-detail",
            title: gettext("File Level Recovery Details"),
            buttons: [
                {
                    text: gettext("Close"),
                    click: function () {
                        $(this).dialog("destroy").remove();
                    }
                }
            ]
        };

        resp = PHD.Ajax.get("/api/jobs/active/flr/" + id + "/?sid=" + system_id);

        resp.done(function (data) {
            // lmc - TODO - right now, we get 'em all.  Eventually we should only get one.
            if (data && data.data !== undefined) {
                var flrs = data.data;
                for (var i = 0; i < flrs.length; i++) {
                    var obj = flrs[i];
                    // find the right one.
                    if (id.indexOf(obj.id) !== -1) {
                        if (obj.share_details === null) {
                            obj.share_details = "None";
                        }
                        if (obj.iscsi_details === null) {
                            obj.str_iscsi_win_details = "N/A";
                            obj.str_iscsi_linux_details = "N/A";
                        } else {
                            obj.str_iscsi_win_details = "On the machine to which you want to restore files, use the " + 
                                                    '<strong>' + "Windows ISCSI Initiator. " + '</strong>' + 
                                                    "The iSCSI target identifier includes the VM name at the end " +
                                                    '<br>' +
                                                    "(example:iqn.1995-21.com.unitrends.dpu:flr.89fb.VMNAME)." +
                                                    '<br><br>' +
                                                    "For details, see " + '<a href="http://www.unitrends.com/documents/rs-ueb-admin-guide/#satori/recovering_files_from_virtual_.htm%3FTocPath%3DRecovering%2520Host-level%2520Backups%7CRecovering%2520files%2520from%2520virtual%2520machine%2520backups%7C_____0" target="_blank"><strong>' + "Recovering files using iSCSI on windows." +
                                                    '</strong></a>';
                            
                            obj.str_iscsi_linux_details = "Login to server or VM to which you want to copy files and download and run " +
                                                        "the script located at " + obj.iscsi_details + '.';
                        }
                        if (obj.comment === null) {
                            obj.comment = "None";
                        }
                        obj.str_admin_url = null;
                        if (obj.admin_url && obj.admin_url != null) {
                            obj.str_admin_url = obj.admin_url;
                        }
                        $("<div>", {
                            id: "flr-detail-" + id,
                            "class": "flr-detail"
                        })
                            .html(flrDetailTmpl(obj))
                            .dialog(options);
                        
                        $(".flr-detail").css("overflow","hidden");
                        $(".flr-detail").height(400);
                        break;
                    }
                }
            }
        });
    };

    function initFilters() {
        $backupCatalog.find(".btn-dateview").on("click", function (event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_DATE;
            updateCatalog(true);
        });

        $backupCatalog.find(".btn-vmview").on("click", function (event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_VM;
            updateCatalog(true);
        });

        $backupCatalog.find(".btn-bdsview").on("click", function (event) {
            event.preventDefault();
            backupCatalogView = BACKUP_CATALOG_VIEW_APPLIANCE;
            updateCatalog(true);
        });

        $backupCatalog.find(".check-select-all").on("change", function (event) {
            if ($(this).prop("checked")) {
                backupCatalog.selectAll();
            } else {
                backupCatalog.deselectAll();
            }
        });

        $backupCatalog.on("afterfilter backupcatalogload", function () {
            tabs[0].updateButtons();
            $backupCatalog.scrollTable({"height": "article"});
        });
    }

    function handleTabChange() {
        tabs[currentTabIndex].update(true);
        $(document).trigger("tabchange", ["recover" + slugs[currentTabIndex]]);
    }

    function initializePage(PHD) {
        console.log('phd is ' + PHD + ' and jquery is ' + jQuery + ' and window is ' + window);
        if (!isNaN(PHD.util.getHashInt())) {
            initialTab = PHD.util.getHashInt();
        }
        $(".with-tooltip").tooltip({
            position: {
                "my": "left top",
                "at": "left bottom",
                "collision": "flip"
            },
            tooltipClass: "button-help"
        });
        $('.tabs-wrapper').tabs({
            active: initialTab,
            create: function (event, ui) {
                currentTabIndex = ui.tab.index();
                initTabs();
                handleTabChange();
            },
            activate: function (event, ui) {
                $(".loading").hide();
                currentTabIndex = ui.newTab.index();
                $.cookie("initial_tab_recover", currentTabIndex, {expires: 365, path: '/'});
                handleTabChange();
            }
        });
    }

    initializePage(PHD);
}
